ExamplesBasics

Path drawing

An example of animating a SVG path to make a path drawing effect, using Motion for React.

React
>Live exampleOpen
Tutorial
Tutorial time
5 min
Difficulty

Introduction

The Path Drawing example shows how to create a drawing animation effect using SVGs and Motion for React.

In this tutorial, we'll use the variants and motion component from Motion for React to create a staggered animation effect across multiple SVG elements.

Get started

Let's start by setting up our SVG container and shapes without animation:

import React from "react"

export default function PathDrawing() {
    return (
        <svg
            width="600"
            height="600"
            viewBox="0 0 600 600"
            style={{ maxWidth: "80vw" }}
        >
            <circle
                cx="100"
                cy="100"
                r="80"
                stroke="#FF0055"
                style={{
                    strokeWidth: 10,
                    strokeLinecap: "round",
                    fill: "transparent",
                }}
            />
            <line
                x1="220"
                y1="30"
                x2="360"
                y2="170"
                stroke="#7700FF"
                style={{
                    strokeWidth: 10,
                    strokeLinecap: "round",
                    fill: "transparent",
                }}
            />
            {/* More shapes would go here */}
        </svg>
    )
}

This creates a basic SVG with circle, cross and square shapes.

Let's animate!

Now let's bring our SVG to life by adding animations.

Import from Motion

First, import the motion component from Motion for React:

import { motion } from "motion/react"

Creating the animation variants

Next, we'll define how our paths should animate. We'll create variants that control the pathLength property, which determines how much of the path is drawn (0 = none, 1 = all):

const draw = {
    hidden: { pathLength: 0, opacity: 0 },
    visible: (i: number) => {
        const delay = i * 0.5
        return {
            pathLength: 1,
            opacity: 1,
            transition: {
                pathLength: { delay, type: "spring", duration: 1.5, bounce: 0 },
                opacity: { delay, duration: 0.01 },
            },
        }
    },
}

Let's break down what's happening:

  • The hidden state sets pathLength: 0 (nothing drawn) and opacity: 0 (invisible).
  • The visible state is a function that accepts a custom index parameter (i). We'll pass this in to each motion.path via its custom prop.
  • The delay is calculated based on this index, creating a staggered effect.

Applying the animation

Now, let's convert our SVG elements to motion components and apply our animation:

export default function PathDrawing() {
    return (
        <motion.svg
            width="600"
            height="600"
            viewBox="0 0 600 600"
            initial="hidden"
            animate="visible"
            style={{ maxWidth: "80vw" }}
        >
            <motion.circle
                cx="100"
                cy="100"
                r="80"
                stroke="#FF0055"
                variants={draw}
                custom={1}
                style={{
                    strokeWidth: 10,
                    strokeLinecap: "round",
                    fill: "transparent",
                }}
            />
            <motion.line
                x1="220"
                y1="30"
                x2="360"
                y2="170"
                stroke="#7700FF"
                variants={draw}
                custom={2}
                style={{
                    strokeWidth: 10,
                    strokeLinecap: "round",
                    fill: "transparent",
                }}
            />
            {/* More shapes would go here */}
        </motion.svg>
    )
}

You can see each path gets its own index, which we use to calculate a staggered delay. The container switches the variant for all its children from "hidden" to "visible".

Conclusion

In this tutorial, we learned how to:

  1. Animate SVG paths using the pathLength property
  2. Create staggered animations using variants and the custom prop
  3. Coordinate multiple animations to create a complex drawing effect

The pathLength property is especially powerful for SVG animations, as it gives the appearance of drawing each shape stroke by stroke. Combined with Motion's animation capabilities, it creates visually appealing drawing effects that would be difficult to achieve with CSS alone.

This technique works with any SVG element that has a stroke, including circles, lines, rectangles, and complex paths. Try experimenting with different timing values, transition types, and SVG shapes to create your own unique drawing animations!

Source code

"use client"

import { motion, Variants } from "motion/react"

const draw: Variants = {
    hidden: { pathLength: 0, opacity: 0 },
    visible: (i: number) => {
        const delay = i * 0.5
        return {
            pathLength: 1,
            opacity: 1,
            transition: {
                pathLength: { delay, type: "spring", duration: 1.5, bounce: 0 },
                opacity: { delay, duration: 0.01 },
            },
        }
    },
}

export default function PathDrawing() {
    return (
        <motion.svg
            width="600"
            height="600"
            viewBox="0 0 600 600"
            initial="hidden"
            animate="visible"
            style={image}
        >
            <motion.circle
                className="circle-path"
                cx="100"
                cy="100"
                r="80"
                stroke="var(--hue-1)"
                variants={draw}
                custom={1}
                style={shape}
            />
            <motion.line
                x1="220"
                y1="30"
                x2="360"
                y2="170"
                stroke="var(--hue-6)"
                variants={draw}
                custom={2}
                style={shape}
            />
            <motion.line
                x1="220"
                y1="170"
                x2="360"
                y2="30"
                stroke="var(--hue-6)"
                variants={draw}
                custom={2.5}
                style={shape}
            />
            <motion.rect
                width="140"
                height="140"
                x="410"
                y="30"
                rx="20"
                stroke="var(--hue-4)"
                variants={draw}
                custom={3}
                style={shape}
            />
            <motion.circle
                cx="100"
                cy="300"
                r="80"
                stroke="var(--hue-4)"
                variants={draw}
                custom={2}
                style={shape}
            />
            <motion.line
                x1="220"
                y1="230"
                x2="360"
                y2="370"
                stroke="var(--hue-1)"
                custom={3}
                variants={draw}
                style={shape}
            />
            <motion.line
                x1="220"
                y1="370"
                x2="360"
                y2="230"
                stroke="var(--hue-1)"
                custom={3.5}
                variants={draw}
                style={shape}
            />
            <motion.rect
                width="140"
                height="140"
                x="410"
                y="230"
                rx="20"
                stroke="var(--hue-6)"
                custom={4}
                variants={draw}
                style={shape}
            />
            <motion.circle
                cx="100"
                cy="500"
                r="80"
                stroke="var(--hue-6)"
                variants={draw}
                custom={3}
                style={shape}
            />
            <motion.line
                x1="220"
                y1="430"
                x2="360"
                y2="570"
                stroke="var(--hue-4)"
                variants={draw}
                custom={4}
                style={shape}
            />
            <motion.line
                x1="220"
                y1="570"
                x2="360"
                y2="430"
                stroke="var(--hue-4)"
                variants={draw}
                custom={4.5}
                style={shape}
            />
            <motion.rect
                width="140"
                height="140"
                x="410"
                y="430"
                rx="20"
                stroke="var(--hue-1)"
                variants={draw}
                custom={5}
                style={shape}
            />
        </motion.svg>
    )
}

/**
 * ==============   Styles   ================
 */

const image: React.CSSProperties = {
    maxWidth: "80vw",
}

const shape: React.CSSProperties = {
    strokeWidth: 10,
    strokeLinecap: "round",
    fill: "transparent",
}

Related examples

Latest in React

ExamplesBasics

Path drawing

An example of animating a SVG path to make a path drawing effect, using Motion for Vue.

Vue
>Live exampleOpen

Source code

<script setup lang="ts">
import { motion } from 'motion-v'

const draw = {
  hidden: { pathLength: 0, opacity: 0 },
  visible: (i) => {
    const delay = i * 0.5
    return {
      pathLength: 1,
      opacity: 1,
      transition: {
        pathLength: { delay, type: "spring", duration: 1.5, bounce: 0 },
        opacity: { delay, duration: 0.01 },
      },
    }
  },
}

/**
 * ==============   Styles   ================
 */

const image = {
  display: "block",
  margin: "0 auto",
  maxWidth: "80vw",
}

const shape = {
  strokeWidth: 10,
  strokeLinecap: "round",
  fill: "transparent",
}
</script>

<template>
  <motion.svg
    width="600"
    height="600"
    viewBox="0 0 600 600"
    initial="hidden"
    animate="visible"
    :style="image"
  >
    <motion.circle
      class="circle-path"
      cx="100"
      cy="100"
      r="80"
      stroke="#ff0088"
      :variants="draw"
      :custom="1"
      :style="shape"
    />
    <motion.line
      x1="220"
      y1="30"
      x2="360"
      y2="170"
      stroke="#4ff0b7"
      :variants="draw"
      :custom="2"
      :style="shape"
    />
    <motion.line
      x1="220"
      y1="170"
      x2="360"
      y2="30"
      stroke="#4ff0b7"
      :variants="draw"
      :custom="2.5"
      :style="shape"
    />
    <motion.rect
      width="140"
      height="140"
      x="410"
      y="30"
      rx="20"
      stroke="#0d63f8"
      :variants="draw"
      :custom="3"
      :style="shape"
    />
    <motion.circle
      cx="100"
      cy="300"
      r="80"
      stroke="#0d63f8"
      :variants="draw"
      :custom="2"
      :style="shape"
    />
    <motion.line
      x1="220"
      y1="230"
      x2="360"
      y2="370"
      stroke="#ff0088"
      :custom="3"
      :variants="draw"
      :style="shape"
    />
    <motion.line
      x1="220"
      y1="370"
      x2="360"
      y2="230"
      stroke="#ff0088"
      :custom="3.5"
      :variants="draw"
      :style="shape"
    />
    <motion.rect
      width="140"
      height="140"
      x="410"
      y="230"
      rx="20"
      stroke="#4ff0b7"
      :custom="4"
      :variants="draw"
      :style="shape"
    />
    <motion.circle
      cx="100"
      cy="500"
      r="80"
      stroke="#4ff0b7"
      :variants="draw"
      :custom="3"
      :style="shape"
    />
    <motion.line
      x1="220"
      y1="430"
      x2="360"
      y2="570"
      stroke="#0d63f8"
      :variants="draw"
      :custom="4"
      :style="shape"
    />
    <motion.line
      x1="220"
      y1="570"
      x2="360"
      y2="430"
      stroke="#0d63f8"
      :variants="draw"
      :custom="4.5"
      :style="shape"
    />
    <motion.rect
      width="140"
      height="140"
      x="410"
      y="430"
      rx="20"
      stroke="#ff0088"
      :variants="draw"
      :custom="5"
      :style="shape"
    />
  </motion.svg>
</template>

Related examples

Latest in Vue